using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

// ACL
using Xclna.Xna.Animation;


namespace ACLTest1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;


        // Reg}l[W̐錾
        MyContentManager myContent;


        // [h郂f
        const int loadModelMax = 10;


        // 3Df̐錾
        List<Model> testModel;

        // 3Df̃TCY䗦
        float testScale = 0.1f;

        // 3Df̉]p
        float testRot = 0;

        // 3Df̍W
        Vector3 testPos;

        // Animator̐錾
        List<ModelAnimator> animator;

        // AnimationController̐錾
        List<AnimationController> controller;


        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            // Reg}l[W̏
            myContent = new MyContentManager(Services);
            myContent.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            // }EXJ[\̕\
            this.IsMouseVisible = true;

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            // TODO: use this.Content to load your game content here


            // 3Df̌Ăяo
            testModel = new List<Model>();
            for (int i = 0; i < loadModelMax; i++)
                testModel.Add(myContent.Load<Model>("SpearMan01"));

            // ModelAnimatorǉ
            animator = new List<ModelAnimator>();
            for (int i = 0; i < testModel.Count; i++)
            {
                animator.Add(new ModelAnimator(this, testModel[i]));
                animator[i].World = Matrix.Identity;
                animator[i].Enabled = true;
                animator[i].Visible = true;
            }

            // AnimationControllerǉA{[ɃZbgB
            controller = new List<AnimationController>();
            for (int i = 0; i < testModel.Count; i++)
            {
                controller.Add(new AnimationController(this, animator[i].Animations["SpearMan01_Attack01"]));
                foreach (BonePose p in animator[i].BonePoses)
                {
                    p.CurrentController = controller[i];
                }
            }
            

            // [hWϊs̐ݒ
            for (int i = 0; i < testModel.Count; i++)
            {
                // [hWϊs
                testPos = new Vector3(i * 50.0f - 100.0f, -150, 0);
                if (i >4)
                    testPos = new Vector3((i - 5) * 50.0f - 100.0f, 0, 0);

                Matrix world = Matrix.CreateScale(testScale)                // gEk
                    * Matrix.CreateRotationY(MathHelper.ToRadians(testRot)) // ]
                    * Matrix.CreateTranslation(testPos);                    // ړ

                // [hWϊs̐ݒ
                animator[i].World = world;
            }


            // r[Wϊs
            Matrix view = Matrix.CreateLookAt(
                new Vector3(0, 0, 300),   // Jʒu
                new Vector3(0, 0, 0),         // J_
                new Vector3(0, 1, 0)          // J
                );

            // ˉeϊs
            Matrix projection = Matrix.CreatePerspectiveFieldOfView(
                MathHelper.ToRadians(45.0f),                   // p
                (float)graphics.GraphicsDevice.Viewport.Width /
                graphics.GraphicsDevice.Viewport.Height,        // AXyNg
                0.1f,                                           // ߃Nbv
                1000.0f                                         // Nbv
            );

            // CgAr[AvWFNV̐ݒ
            for (int i = 0; i < testModel.Count; i++)
            {
                foreach (ModelMesh mesh in testModel[i].Meshes)
                {
                    // GtFNgݒ
                    foreach (Effect effect in mesh.Effects)
                    {
                        BasicPaletteEffect ef = (BasicPaletteEffect)effect;
                        // r[Wϊsw
                        ef.Parameters["View"].SetValue(view);
                        // ˉeϊsw
                        ef.Parameters["Projection"].SetValue(projection);
                        // CeBOiIj
                        ef.EnableDefaultLighting();
                    }
                }
            }

            // CX^XɃ[VĐx炷
            for (int i = 0; i < testModel.Count; i++)
            {
                controller[i].SpeedFactor = (i + 1) * 0.1f;
            }
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            // Lݒς̏ꍇAACL̓fIɕ`悷iDraw\bhLqsvj
            // animator[i].Enabled = true;
            // animator[i].Visible = true;

            // Console.WriteLine("{[F" + testModel[0].Bones.Count.ToString());

            base.Draw(gameTime);
        }
    }
}

